show.param = function(fit, param.name)
   {x = ss(fit$tmm, param == param.name)
    x$s = factor(x$s, levels = rev(row.names(fit$each.s)))
      # So the best-predicted subject is on the left and the
      # worst-predicted is on the right.
    ggplot(data = x) +
        geom_pointrange(aes(x = s, ymin = lo, y = mean, ymax = hi)) +
        theme(
            axis.text.x = element_text(angle = 90, hjust = 1),
            panel.grid.major.x = element_blank()) +
        ylab(param.name)}

shuffle.trial.types = function(ts)
    ddply(ts, .(s), function(slice)
        transform(slice, type = sample(type)))

caught = function(p)
    ss(ts, s %in% ssq(sb, p)$s & type == "catch" & choice == "ll")

test.set.consistency = function(ses)
   {x = aggregate(choice ~ model + qn,
        transform(ss(ts, type == "test" & s %in% ses),
            model = sb[char(s), "model"]),
        FUN = function (v) mean(v == "ll"))
    mins = aggregate(choice ~ qn, x, FUN = min)
    maxes = aggregate(choice ~ qn, x, FUN = max)
    mm = rbind(mins, maxes)
    list(
        quantiles = quantile(maxes$choice - mins$choice, c(.025, .5, .975)),
        plot = ggplot() +
            geom_line(aes(choice, qn, group = qn),
                data = mm) +
            geom_point(aes(choice, qn, color = model),
                data = x) +
            scale_y_quartet +
            scale_x_continuous(
                name = "proportion LL",
                limits = c(0, 1),
                expand = c(0, 0),
                breaks = seq(0, 1, .2)) +
            theme(
                axis.text.y = element_text(size = 9, hjust = 1),
                panel.grid.major.y = element_blank(),
            panel.grid.minor.y = element_blank()))}
