show.test.choices = function(the.s)
    cbind(
        ordf(
            aggregate(
                choice ~ qn + ssr + ssd + llr + lld,
                ss(ts, type == "test" & s %in% good.s),
                function(v) mean(v == "ll")),
            qn),
        o = ordf(
            ss(ts, s == the.s & type == "test"), qn)$choice)

summarize.posterior = function(posterior, ts.test = NULL, choice.p = NULL)
   {params = dimnames(posterior)[[2]]
    d = do.call(rbind, mapcols(posterior, function(v)
       {q = quantile(v, c(.025, .975))
        data.frame(
            param = "", trial = NA,
            lo = q[1],
            mean = mean(v),
            hi = q[2],
            irng = q[2] - q[1],
            ppos = mean(v > 0))}))
    row.names(d) = d$param = factor(params, levels = params)
    if (!is.null(ts.test))
       {post.list = col.list(posterior)
        d = rbind(d, t(sapply(1 : nrow(ts.test), function(t)
           {ps = do.call(choice.p, c(list(ts.test[t,]), post.list))
            q = as.vector(quantile(ps, c(.025, .975)))
            c(
                param = NA, trial = t,
                lo = q[1],
                mean = mean(ps),
                hi = q[2],
                irng = q[2] - q[1],
                ppos = 1)})))}
    d}

col.list = function(m)
# Turns a matrix into a list of columns, like as.data.frame.
    lapply(1 : ncol(m), function(i) m[,i])
